typedef struct __Sem_t 
{
	int value;
	pthread_cond_t cond;
	pthread_mutex_t lock;
} Sem_t;

// only one thread can call this
void Sem_init(Sem_t *s, int value) 
{
	s->value = value;
	Cond_init(&s->cond);
	Mutex_init(&s->lock);
}

void Sem_wait(Sem_t *s) 
{
	Mutex_lock(&s->lock);
	while (s->value <= 0)
	Cond_wait(&s->cond, &s->lock);
	s->value--;
	Mutex_unlock(&s->lock);
}

void Sem_post(Sem_t *s) 
{
	Mutex_lock(&s->lock);
	s->value++;
	Cond_signal(&s->cond);
	Mutex_unlock(&s->lock);
}
